
CREATE TABLE SysVars (
varname VARCHAR(255) NOT NULL,
varval LONG VARCHAR NOT NULL,
CONSTRAINT sysvars_primary_key PRIMARY KEY (varname)
);

CREATE TABLE UserGroup (
name VARCHAR(511) NOT NULL,
CONSTRAINT usergroup_primary_key PRIMARY KEY (name)
);

CREATE TABLE UserProfile (
UID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1),
uniqueServerUID VARCHAR(511) NOT NULL DEFAULT '',
system BOOLEAN NOT NULL DEFAULT false,
administrator BOOLEAN NOT NULL DEFAULT false,
isPoweruser BOOLEAN NOT NULL DEFAULT false,
networkMode BOOLEAN NOT NULL DEFAULT false,
networkUsersCount INTEGER NOT NULL DEFAULT 0,
canEditAccounts BOOLEAN NOT NULL DEFAULT false,
canEditSettings BOOLEAN NOT NULL DEFAULT false,
canInstallUpdates BOOLEAN NOT NULL DEFAULT false,
canPerformSeal BOOLEAN NOT NULL DEFAULT false, 
confirmed BOOLEAN NOT NULL DEFAULT false,
blocked BOOLEAN NOT NULL DEFAULT false,
invalidated BOOLEAN NOT NULL DEFAULT false,
deliveredToClient BOOLEAN NOT NULL DEFAULT false,
PIB VARCHAR(31) NOT NULL DEFAULT '',
clID1 VARCHAR(31) NOT NULL DEFAULT '',
clID2 VARCHAR(31) NOT NULL DEFAULT '',
userGroup_name VARCHAR(511) NOT NULL,
password VARCHAR(511) NOT NULL DEFAULT '',
passwordProtected BOOLEAN NOT NULL DEFAULT true,
emailSendEnabled BOOLEAN NOT NULL DEFAULT true,
canEditAddressBook BOOLEAN NOT NULL DEFAULT true,
editAddresspassword VARCHAR(511) NOT NULL DEFAULT '',

billingCenter INTEGER NOT NULL DEFAULT 1,
billingLabel INTEGER NOT NULL DEFAULT 1,
serviceCenter INTEGER NOT NULL DEFAULT -1,
cargoNetID INTEGER NOT NULL DEFAULT -1,
name VARCHAR(511) NOT NULL,
displayName VARCHAR(511) NOT NULL DEFAULT '',
contactPerson VARCHAR(511) NOT NULL DEFAULT '',
address VARCHAR(1023) NOT NULL DEFAULT '',
addressHouseNr VARCHAR(31) NOT NULL DEFAULT '',
postalCode VARCHAR(11) NOT NULL DEFAULT '',
city VARCHAR(511) NOT NULL DEFAULT '',
countryCode VARCHAR(32) NOT NULL DEFAULT '_UNDEFINED',
stickerDesignType VARCHAR(127) NOT NULL DEFAULT 'DEFAULT',
abroadShippingAllowed BOOLEAN NOT NULL DEFAULT false,
abroadServicePerDestCountryAllowance VARCHAR(2047) NOT NULL DEFAULT '',
currencyNational BOOLEAN NOT NULL DEFAULT false,
countriesAllowed VARCHAR(511) NOT NULL DEFAULT '',
CODcurrencyMap VARCHAR(511) NOT NULL DEFAULT '',

phone VARCHAR(255) NOT NULL DEFAULT '',
faxNr VARCHAR(255) NOT NULL DEFAULT '',
gsmTel VARCHAR(255) NOT NULL DEFAULT '',
email VARCHAR(511) NOT NULL DEFAULT '',
email2 VARCHAR(511) NOT NULL DEFAULT '',
notificationType VARCHAR(15) NOT NULL DEFAULT 'NONE',
bankAccoutID VARCHAR(255) NOT NULL DEFAULT '',
createTimestamp TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
lastEditTimestamp TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,

printerNameStickers VARCHAR(511) NOT NULL DEFAULT '',
printerPDFStickers BOOLEAN NOT NULL DEFAULT false,
printerNameReport VARCHAR(511) NOT NULL DEFAULT '',
printerPDFReport BOOLEAN NOT NULL DEFAULT false,
printerNameMiniReport VARCHAR(511) NOT NULL DEFAULT '',
printerPDFMiniReport BOOLEAN NOT NULL DEFAULT false,

printStickersFormat VARCHAR(63) NOT NULL DEFAULT 'A4',
printStickersMediaTray VARCHAR(63) NOT NULL DEFAULT 'MAIN',
printStickersRotate180 BOOLEAN NOT NULL DEFAULT false,
printReferenceNr1 BOOLEAN NOT NULL DEFAULT true,
printMiniLabels BOOLEAN NOT NULL DEFAULT false,

printReport BOOLEAN NOT NULL DEFAULT true,
printReportCopies INTEGER NOT NULL DEFAULT 2,
printReportDelyList BOOLEAN NOT NULL DEFAULT false,
printReportDelyListCopies INTEGER NOT NULL DEFAULT 2,
printMiniReport BOOLEAN NOT NULL DEFAULT false,
printMiniReportCopies INTEGER NOT NULL DEFAULT 1,

printDelyListWithoutBarcodes BOOLEAN NOT NULL DEFAULT false,
printMiniReportWithoutBarcodes BOOLEAN NOT NULL DEFAULT false,

printShipperLogo BOOLEAN NOT NULL DEFAULT false,
printPauseAfterStickers BOOLEAN NOT NULL DEFAULT false,
printCancelIfOptionNotSupported BOOLEAN NOT NULL DEFAULT false,
printInformUserWhenFinished BOOLEAN NOT NULL DEFAULT true,
shipperLogoImage BLOB,

eobdIncludeInvalidatedShipments BOOLEAN NOT NULL DEFAULT true,

editorsHighlightActiveField BOOLEAN NOT NULL DEFAULT false,
editorsUseEnterBtnAsTab BOOLEAN NOT NULL DEFAULT false,
editorsUseFancySaving BOOLEAN NOT NULL DEFAULT false,
editorCustomerSaveOpensNew BOOLEAN NOT NULL DEFAULT false,
editorShipmentSaveOpensNew BOOLEAN NOT NULL DEFAULT false,
editorShipmentReference1PerParcel BOOLEAN NOT NULL DEFAULT false,
editorShipmentSavePrintsSticker BOOLEAN NOT NULL DEFAULT false,
editorShipmentKeepReceiver BOOLEAN NOT NULL DEFAULT false,
editorShipmentKeepReference1 BOOLEAN NOT NULL DEFAULT false,
editorShipmentKeepReference2 BOOLEAN NOT NULL DEFAULT false,
editorShipmentKeepReference3 BOOLEAN NOT NULL DEFAULT false,
editorShipmentKeepServices BOOLEAN NOT NULL DEFAULT false,
editorShipmentKeepServicesList VARCHAR(1024) NOT NULL DEFAULT '',
editorShipmentKeepVehicle BOOLEAN NOT NULL DEFAULT false,
editorShipmentKeepNumberOfPackets BOOLEAN NOT NULL DEFAULT false,
editorShipmentKeepBillBaseType BOOLEAN NOT NULL DEFAULT false,
editorShipmentKeepBillBaseData BOOLEAN NOT NULL DEFAULT false,
// editorShipmentShowNextWorkingDayInfo BOOLEAN NOT NULL DEFAULT true,
editorAutoFillReference2FromContactPerson BOOLEAN NOT NULL DEFAULT false,
editorAutoActivateCOD BOOLEAN NOT NULL DEFAULT false,

// editorShipmentKeepCODValue BOOLEAN NOT NULL DEFAULT false,
// editorShipmentKeepCODPaymentMethod BOOLEAN NOT NULL DEFAULT true,

featureAutoimport BOOLEAN NOT NULL DEFAULT false,
featureVehicleSelection BOOLEAN NOT NULL DEFAULT false,
autoNumberRangesAsignmentEnabled BOOLEAN NOT NULL DEFAULT false,
autoInitNumberRanges BOOLEAN NOT NULL DEFAULT false,

autoNumberRangesRequestedToday INTEGER NOT NULL DEFAULT 0,
autoNumberRangesDailyAllowance INTEGER NOT NULL DEFAULT 3000,

paymentCODCashAllowed BOOLEAN NOT NULL DEFAULT true,
paymentViamoAllowed BOOLEAN NOT NULL DEFAULT false,
paymentCreditCardAllowed BOOLEAN NOT NULL DEFAULT false,
paymentReturnCashCRCAllowed BOOLEAN NOT NULL DEFAULT false,
paymentCODDefaultOption VARCHAR(64) NOT NULL DEFAULT 'DEFAULT_NATIONAL',

connectionMode VARCHAR(64) NOT NULL DEFAULT 'PERMANENT',
connectionAutoSend BOOLEAN NOT NULL DEFAULT true,
connectionManualPreferredConnection VARCHAR(511) NOT NULL DEFAULT '',
connectionManualAutoDialHang BOOLEAN NOT NULL DEFAULT false,
filesAskUserAlways BOOLEAN NOT NULL DEFAULT false,
filesDefaultFolder VARCHAR(1023) NOT NULL DEFAULT '',

stats_clientVersion VARCHAR(255) NOT NULL DEFAULT '',
stats_clientOS VARCHAR(31) NOT NULL DEFAULT '',
stats_lastReportSent TIMESTAMP NOT NULL DEFAULT '1900-01-01 00:00:00',
stats_trkNumbersAvailable INTEGER NOT NULL DEFAULT 0,
stats_trkWarningLevel INTEGER NOT NULL DEFAULT 0,

addressBookShared_UID INTEGER NOT NULL DEFAULT 0,
backupAddresses BOOLEAN NOT NULL DEFAULT true,
backupShipments BOOLEAN NOT NULL DEFAULT true,
backupShipmentsMaxDays INTEGER NOT NULL DEFAULT 90,
backupMode VARCHAR(63) NOT NULL DEFAULT 'FULL',
backupTime VARCHAR(63) NOT NULL DEFAULT 'DAILY_ON_LOGOUT',
backupDefaultFolder VARCHAR(1023) NOT NULL DEFAULT '',

// deprecated; use featureAutoimport
autoImportEnabled BOOLEAN NOT NULL DEFAULT false,

autoImportDefaultFolder VARCHAR(1023) NOT NULL DEFAULT '',
autoImportAutoPrintStickers BOOLEAN NOT NULL DEFAULT true,

autoImportShipmentMethod VARCHAR(255) NOT NULL DEFAULT 'CIF',
autoImportShipmentProfile_UID INTEGER NOT NULL DEFAULT 0,
autoImportShipmentFolder VARCHAR(1023) NOT NULL DEFAULT '',

featurePaletteManagementEnabled BOOLEAN NOT NULL DEFAULT false,
optionRef1COD BOOLEAN NOT NULL DEFAULT false,

allowImportExtensionsCE01 BOOLEAN NOT NULL DEFAULT false,

printRoutingLabelOnSticker BOOLEAN NOT NULL DEFAULT false,
enableRoutingWebService BOOLEAN NOT NULL DEFAULT false,

smtpHost VARCHAR(511) NOT NULL DEFAULT '',
smtpPort INTEGER NOT NULL DEFAULT 0,
imapHost VARCHAR(511) NOT NULL DEFAULT '',
imapPort INTEGER NOT NULL DEFAULT 0,
smtpSTARTTLS BOOLEAN NOT NULL DEFAULT false,
smtpSSLTLS BOOLEAN NOT NULL DEFAULT false,
smtpAuth BOOLEAN NOT NULL DEFAULT false,
smtpUser VARCHAR(511) NOT NULL DEFAULT '',
smtpPass VARCHAR(511) NOT NULL DEFAULT '',
smtpFrom VARCHAR(511) NOT NULL DEFAULT '',
smtpAddress VARCHAR(511) NOT NULL DEFAULT '',
smtpReplyTo VARCHAR(511) NOT NULL DEFAULT '',

CONSTRAINT userprofile_primary_key PRIMARY KEY (UID),
CONSTRAINT userprofile_usergroup_foreign_key FOREIGN KEY (userGroup_name) REFERENCES UserGroup(name) ON DELETE RESTRICT
// ,
// CONSTRAINT userprofile_name_unique UNIQUE (name)
);

CREATE TABLE ResellerProfile (
UID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1),
uniqueServerUID VARCHAR(511) NOT NULL DEFAULT '',
blocked BOOLEAN NOT NULL DEFAULT false,
invalidated BOOLEAN NOT NULL DEFAULT false,
resellerID VARCHAR(511) NOT NULL DEFAULT '',
customID VARCHAR(511) NOT NULL DEFAULT '',
groupName VARCHAR(511) NOT NULL DEFAULT '',
regionName VARCHAR(511) NOT NULL DEFAULT '',
username VARCHAR(511) NOT NULL DEFAULT '',
password VARCHAR(511) NOT NULL DEFAULT '',
billingCenter INTEGER NOT NULL DEFAULT -1,
serviceCenter INTEGER NOT NULL DEFAULT -1,
firstName VARCHAR(511) NOT NULL,
lastName VARCHAR(511) NOT NULL,
address VARCHAR(1023) NOT NULL DEFAULT '',
addressHouseNr VARCHAR(31) NOT NULL DEFAULT '',
postalCode VARCHAR(11) NOT NULL DEFAULT '',
city VARCHAR(511) NOT NULL DEFAULT '',
countryCode VARCHAR(32) NOT NULL DEFAULT '_UNDEFINED',
phone VARCHAR(255) NOT NULL DEFAULT '',
faxNr VARCHAR(255) NOT NULL DEFAULT '',
gsmTel VARCHAR(255) NOT NULL DEFAULT '',
email VARCHAR(511) NOT NULL DEFAULT '',
email2 VARCHAR(511) NOT NULL DEFAULT '',
bankAccoutID VARCHAR(255) NOT NULL DEFAULT '',
description CLOB NOT NULL DEFAULT '',
createTimestamp TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
lastEditTimestamp TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
CONSTRAINT resellerprofile_primary_key PRIMARY KEY (UID)
);

CREATE TABLE Rel_ResellerToCustomer (
resellerUUID VARCHAR(511) NOT NULL,
customerUUID VARCHAR(511) NOT NULL,
createTimestamp TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
reasonID INTEGER NOT NULL DEFAULT 0,
CONSTRAINT rel_resellertocustomer_primary_key PRIMARY KEY (resellerUUID, customerUUID)
);

CREATE TABLE EOBDReport (
UID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1),
multiReport BOOLEAN NOT NULL DEFAULT false,
multiReportCriteria VARCHAR(31) NOT NULL DEFAULT 'NONE',
userProfile_UID INTEGER NOT NULL,
uniqueServerUID VARCHAR(511) NOT NULL DEFAULT '',
xmlContent CLOB,
printTimestamp TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
deliveryTimestamp TIMESTAMP NOT NULL DEFAULT '1900-01-01 00:00:00',
deliveredToServer BOOLEAN NOT NULL DEFAULT false,
serverConfirmed BOOLEAN NOT NULL DEFAULT false,
invalidated BOOLEAN NOT NULL DEFAULT false,
numberOfShipments INTEGER NOT NULL DEFAULT 0,
numberOfParcelsValid INTEGER NOT NULL DEFAULT 0,
numberOfParcelsInvalidated INTEGER NOT NULL DEFAULT 0,
totalShipmentsImported INTEGER NOT NULL DEFAULT 0,
totalShipmentsAutoImported INTEGER NOT NULL DEFAULT 0,
totalPalettesEuro INTEGER NOT NULL DEFAULT 0,
totalPalettesCommon INTEGER NOT NULL DEFAULT 0,
totalPalettesThermo INTEGER NOT NULL DEFAULT 0,
CONSTRAINT eobdreport_primary_key PRIMARY KEY (UID),
CONSTRAINT eobdreport_userprofile_foreign_key FOREIGN KEY (userProfile_UID) REFERENCES UserProfile(UID) ON DELETE CASCADE
);

CREATE TABLE ImportDataProfile (
UID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1),
userProfile_UID INTEGER NOT NULL,
name VARCHAR(511) NOT NULL,
profileType VARCHAR(511) NOT NULL DEFAULT 'ADDRESS',
codePage VARCHAR(64) NOT NULL,
separatorChar SMALLINT NOT NULL,
firstRowIsHeader BOOLEAN NOT NULL DEFAULT false,
isDefault BOOLEAN NOT NULL DEFAULT false,
CONSTRAINT importdataprofile_primary_key PRIMARY KEY (UID),
CONSTRAINT importdataprofile_userprofile_foreign_key FOREIGN KEY (userProfile_UID) REFERENCES UserProfile(UID) ON DELETE CASCADE
);

CREATE TABLE ImportDataProfileConnection (
UID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1),
importDataProfile_UID INTEGER NOT NULL,
externalFieldTitle VARCHAR(511) NOT NULL DEFAULT '',
externalFieldID VARCHAR(511) NOT NULL,
expeditFieldID VARCHAR(511) NOT NULL,
virtualColumn BOOLEAN NOT NULL DEFAULT false,
virtualColumnValue VARCHAR(511) NOT NULL DEFAULT '',
ordinalNr SMALLINT NOT NULL DEFAULT 1,
CONSTRAINT importdataprofileconnection_primary_key PRIMARY KEY (UID),
CONSTRAINT importdataprofileconnection_importdataprofile_foreign_key FOREIGN KEY (importDataProfile_UID) REFERENCES ImportDataProfile(UID) ON DELETE CASCADE
);

CREATE TABLE Customer (
UID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1),
userProfile_UID INTEGER NOT NULL,
cargoNetID INTEGER NOT NULL DEFAULT -1,
name VARCHAR(511) NOT NULL,
displayName VARCHAR(511) NOT NULL DEFAULT '',
PIB VARCHAR(511) NOT NULL DEFAULT '',
companyNumber VARCHAR(511) NOT NULL DEFAULT '',
contactPerson VARCHAR(511) NOT NULL DEFAULT '',
address VARCHAR(511) NOT NULL,
postalCode VARCHAR(11) NOT NULL,
postalCodeSuffix VARCHAR(11) NOT NULL,
city VARCHAR(511) NOT NULL,
countryCode VARCHAR(32) NOT NULL DEFAULT '_UNDEFINED',
phone VARCHAR(255) NOT NULL DEFAULT '',
phone2 VARCHAR(255) NOT NULL DEFAULT '',
faxNr VARCHAR(255) NOT NULL DEFAULT '',
gsmTel VARCHAR(255) NOT NULL DEFAULT '',
email VARCHAR(255) NOT NULL DEFAULT '',
email2 VARCHAR(255) NOT NULL DEFAULT '',
notificationType VARCHAR(255) NOT NULL DEFAULT 'NONE',
cashOnDeliveryOnly BOOLEAN NOT NULL DEFAULT false,
bankAccoutID VARCHAR(255) NOT NULL DEFAULT '',
receiverServices VARCHAR(511) NOT NULL DEFAULT '',
description CLOB NOT NULL DEFAULT '',
backupPerformed BOOLEAN NOT NULL DEFAULT false,
CONSTRAINT customer_primary_key PRIMARY KEY (UID)
//,
//
// Can cause a problem with shared address books, if merge owner is deleted than whole address book is deleted
// 
// CONSTRAINT customer_userprofile_foreign_key FOREIGN KEY (userProfile_UID) REFERENCES UserProfile(UID) ON DELETE CASCADE
//
);

CREATE TABLE Shipment (
UID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1),
userProfile_UID INTEGER NOT NULL,
EOBD_UID INTEGER NOT NULL DEFAULT 0,
active BOOLEAN NOT NULL DEFAULT true,
invalidated BOOLEAN NOT NULL DEFAULT false,
imported BOOLEAN NOT NULL DEFAULT false,
importMethod SMALLINT NOT NULL DEFAULT 0,
printed BOOLEAN NOT NULL DEFAULT false,
mergedMaster BOOLEAN NOT NULL DEFAULT false,
mergedSlave BOOLEAN NOT NULL DEFAULT false,
letter BOOLEAN NOT NULL DEFAULT false,
numberOfCollis SMALLINT NOT NULL DEFAULT 1,
billBaseType VARCHAR(64) NOT NULL DEFAULT 'WEIGHT',
billBaseValue DOUBLE NOT NULL DEFAULT 0.0,
totalWeight DOUBLE NOT NULL DEFAULT 0.0,
wineBoxType SMALLINT NOT NULL DEFAULT 0,
dropBoxType INT NOT NULL DEFAULT 0,
consigneeCargoNetID INTEGER NOT NULL DEFAULT -1,
consigneeName VARCHAR(511) NOT NULL,
consigneeContactPerson VARCHAR(511) NOT NULL,
consigneeCountryCode VARCHAR(32) NOT NULL,
consigneePLZ VARCHAR(11) NOT NULL,
consigneePLZSuffix VARCHAR(11) NOT NULL,
consigneeCity VARCHAR(511) NOT NULL,
consigneeStreet VARCHAR(511) NOT NULL,
consigneeTel VARCHAR(511) NOT NULL,
consigneeFax VARCHAR(511) NOT NULL,
consigneeNotificationGSM VARCHAR(511) NOT NULL,
consigneeNotificationEmail VARCHAR(511) NOT NULL,
consigneeNotificationType VARCHAR(64) NOT NULL DEFAULT 'NONE',
consigneeBankAccoutID VARCHAR(255) NOT NULL DEFAULT '',
shipperCargoNetID INTEGER NOT NULL DEFAULT -1,
shipperName VARCHAR(511) NOT NULL,
shipperDisplayName VARCHAR(511) NOT NULL DEFAULT '',
shipperContactPerson VARCHAR(511) NOT NULL,
shipperCountryCode VARCHAR(32) NOT NULL,
shipperPLZ VARCHAR(11) NOT NULL,
shipperPLZSuffix VARCHAR(11) NOT NULL,
shipperCity VARCHAR(511) NOT NULL,
shipperStreet VARCHAR(511) NOT NULL,
shipperTel VARCHAR(511) NOT NULL,
shipperFax VARCHAR(511) NOT NULL,
shipperNotificationGSM VARCHAR(511) NOT NULL,
shipperNotificationEmail VARCHAR(511) NOT NULL,
shipperNotificationType VARCHAR(64) NOT NULL DEFAULT 'NONE',
shipperBankAccoutID VARCHAR(255) NOT NULL DEFAULT '',
reference1 VARCHAR(511) NOT NULL,
internationalReference VARCHAR(511) NOT NULL,
reference2 VARCHAR(511) NOT NULL,
reference3 VARCHAR(511) NOT NULL,
reference1Cache VARCHAR(16383) NOT NULL DEFAULT '',
reference2Cache VARCHAR(16383) NOT NULL DEFAULT '',
reference3Cache VARCHAR(16383) NOT NULL DEFAULT '',
cashOnDeliveryValue DOUBLE NOT NULL DEFAULT 0.0,
cashOnDeliveryCurrency INT NOT NULL DEFAULT 0,
cashOnDeliveryPaymentOption INT NOT NULL DEFAULT 0,
codReturnBankCode VARCHAR(16) NOT NULL DEFAULT '',
codReturnBankAccount VARCHAR(36) NOT NULL DEFAULT '',
codRequired BOOLEAN NOT NULL DEFAULT false,
expressDocumentBAFormat VARCHAR(255) NOT NULL DEFAULT 'A4',
insuranceValue DOUBLE NOT NULL DEFAULT 0.0,
cargo VARCHAR(2) NOT NULL DEFAULT '',
personalDeliveryName VARCHAR(511) NOT NULL,
senderNotificationGSM VARCHAR(127) NOT NULL DEFAULT '',
senderNotificationEmail VARCHAR(511) NOT NULL DEFAULT '',
remark VARCHAR(511) NOT NULL,
pickupRemark VARCHAR(511) NOT NULL,
deliveryRemark VARCHAR(511) NOT NULL,
createTimestamp TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
lastEditTimestamp TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
pickupOrderTimestamp TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
pickupOrderLatestTimestamp TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,

vehicleUID INTEGER NOT NULL DEFAULT 1,

tt_LastCheck TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
tt_StatusCode VARCHAR(15) NOT NULL DEFAULT '',
tt_StatusDescription VARCHAR(255) NOT NULL DEFAULT '',
tt_RecipientName VARCHAR(255) NOT NULL DEFAULT '',
tt_DelyDate TIMESTAMP NOT NULL DEFAULT '1900-01-01 00:00:00',
tt_Weight DOUBLE NOT NULL DEFAULT 0.0,

backupPerformed BOOLEAN NOT NULL DEFAULT false,

palletsEuro INTEGER NOT NULL DEFAULT 0,
palletsCommon INTEGER NOT NULL DEFAULT 0,
palletsThermo INTEGER NOT NULL DEFAULT 0,

sealed BOOLEAN NOT NULL DEFAULT false,
sealMaster BOOLEAN NOT NULL DEFAULT false,
sealExternalBarcode VARCHAR(255) NOT NULL DEFAULT '',

crcMasterCargoID BIGINT NOT NULL DEFAULT 0,
forcedSenderDataSet BOOLEAN NOT NULL DEFAULT false,
customRouteCenterCode VARCHAR(63) NOT NULL DEFAULT '',
customRouteNr INTEGER NOT NULL DEFAULT 0,

CONSTRAINT shipment_primary_key PRIMARY KEY (UID),
CONSTRAINT shipment_userprofile_foreign_key FOREIGN KEY (userProfile_UID) REFERENCES UserProfile(UID) ON DELETE CASCADE
);

CREATE TABLE Packet (
UID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1),
shipment_UID INTEGER NOT NULL,
weight DOUBLE NOT NULL DEFAULT 0.0,
invalidated BOOLEAN NOT NULL DEFAULT false,
ordinalNr SMALLINT NOT NULL DEFAULT 1,
trackingSerie_UID INTEGER NOT NULL,
globalOrdinalNr VARCHAR(63) NOT NULL,
trackingCodeBase VARCHAR(63) NOT NULL DEFAULT '0',
trackingCodeComplete VARCHAR(63) NOT NULL DEFAULT '0',
trackingMultifunctionalCode VARCHAR(63) NOT NULL DEFAULT '0',
printTimestamp TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
reference1 VARCHAR(511) NOT NULL DEFAULT '',
reference2 VARCHAR(511) NOT NULL DEFAULT '',
reference3 VARCHAR(511) NOT NULL DEFAULT '',
tt_DelyDate TIMESTAMP NOT NULL DEFAULT '1900-01-01 00:00:00',
tt_StatusCode VARCHAR(15) NOT NULL DEFAULT '',
tt_StatusDescription VARCHAR(255) NOT NULL DEFAULT '',
CONSTRAINT packet_primary_key PRIMARY KEY (UID),
CONSTRAINT packet_shipment_foreign_key FOREIGN KEY (shipment_UID) REFERENCES Shipment(UID) ON DELETE CASCADE
);

CREATE TABLE ServiceGroup (
UID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1),
name VARCHAR(511) NOT NULL,
ordinalNr SMALLINT NOT NULL DEFAULT 1,
multipleSelect BOOLEAN NOT NULL DEFAULT false,
CONSTRAINT servicegroup_primary_key PRIMARY KEY (UID),
CONSTRAINT servicegroup_name_unique UNIQUE (name)
);

CREATE TABLE Service (
UID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1),
userGroup_name VARCHAR(511) NOT NULL,
serviceGroup_name VARCHAR(511) NOT NULL DEFAULT 'NON_GROUPED_SERVICE',
mandat_name VARCHAR(511) NOT NULL DEFAULT 'NATIONAL',
code VARCHAR(511) NOT NULL,
enabled BOOLEAN NOT NULL DEFAULT true,
visible BOOLEAN NOT NULL DEFAULT true,
ordinalNr SMALLINT NOT NULL DEFAULT 1,
printOrdinalNr SMALLINT NOT NULL DEFAULT 1,
selectableByUser BOOLEAN NOT NULL DEFAULT true,
selectedByDefault BOOLEAN NOT NULL DEFAULT false,
disablesServices VARCHAR(2047) NOT NULL DEFAULT '',
sinceVersion VARCHAR(255) NOT NULL DEFAULT '1.0.0',
CONSTRAINT service_primary_key PRIMARY KEY (UID),
CONSTRAINT service_usergroup_foreign_key FOREIGN KEY (userGroup_name) REFERENCES UserGroup(name) ON DELETE CASCADE,
CONSTRAINT service_servicegroup_foreign_key FOREIGN KEY (serviceGroup_name) REFERENCES ServiceGroup(name) ON DELETE RESTRICT
);
// Disables Service defines
// General rules about the services that cannot be selected at the same time
//

//
// Enabled/Disabled service on the user level (globals take precedence)
//
CREATE TABLE PerUserService (
UID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1),
userProfile_UID INTEGER NOT NULL,
serviceGroup_name VARCHAR(511) NOT NULL DEFAULT 'NON_GROUPED_SERVICE',
code VARCHAR(511) NOT NULL,
enabled BOOLEAN NOT NULL DEFAULT true,
visible BOOLEAN NOT NULL DEFAULT true,
ordinalNr SMALLINT NOT NULL DEFAULT 1,
printOrdinalNr SMALLINT NOT NULL DEFAULT 1,
selectableByUser BOOLEAN NOT NULL DEFAULT true,
selectedByDefault BOOLEAN NOT NULL DEFAULT false,
disablesServices VARCHAR(2047) NOT NULL DEFAULT '',
sinceVersion VARCHAR(255) NOT NULL DEFAULT '1.0.0',
CONSTRAINT peruserservice_primary_key PRIMARY KEY (UID),
CONSTRAINT peruserservice_userprofile_foreign_key FOREIGN KEY (userProfile_UID) REFERENCES UserProfile(UID) ON DELETE CASCADE
);

//
// Default service settings on CargoID level
//
CREATE TABLE PerCIDUserService (
UID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1),
userGroup_name VARCHAR(511) NOT NULL,
mandat_name VARCHAR(511) NOT NULL DEFAULT 'NATIONAL',
cargoID INT NOT NULL DEFAULT -1,
code VARCHAR(511) NOT NULL,
enabled BOOLEAN NOT NULL DEFAULT true,
CONSTRAINT percidservice_primary_key PRIMARY KEY (UID)
);

CREATE TABLE ShipmentService (
UID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1),
shipment_UID INTEGER NOT NULL,
serviceCode VARCHAR(511) NOT NULL,
CONSTRAINT shipmentservice_primary_key PRIMARY KEY (UID),
CONSTRAINT shipmentservice_shipment_foreign_key FOREIGN KEY (shipment_UID) REFERENCES Shipment(UID) ON DELETE CASCADE
);

CREATE TABLE BillingOption (
UID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1),
userGroup_name VARCHAR(511) NOT NULL,
code VARCHAR(511) NOT NULL,
enabled BOOLEAN NOT NULL DEFAULT true,
ordinalNr SMALLINT NOT NULL DEFAULT 1,
selectedByDefault BOOLEAN NOT NULL DEFAULT false,
disablesServices VARCHAR(2047) NOT NULL DEFAULT '',
CONSTRAINT billingOption_usergroup_foreign_key FOREIGN KEY (userGroup_name) REFERENCES UserGroup(name) ON DELETE CASCADE,
CONSTRAINT billingOption_primary_key PRIMARY KEY (UID)
);
//
// BillBases related to Services
// if defined, service with this serviceCode will be disabled if billbaseTypeCode is selected (in GUI)
//   


//
// BillBases related to Services, per user
// The service disabled per user takes precedence over the global option
//
// This Table is not used yet
//   
//CREATE TABLE BillingOptionDisabledServicePerUser (
//UID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1),
//userProfile_UID INTEGER NOT NULL,
//billingOptionCode VARCHAR(511) NOT NULL,
//serviceCode VARCHAR(511) NOT NULL,
//CONSTRAINT billingOptionDisabledServicePerUser_primary_key PRIMARY KEY (UID),
//CONSTRAINT billingOptionDisabledServicePerUser_userprofile_foreign_key FOREIGN KEY (userProfile_UID) REFERENCES UserProfile(UID) ON DELETE CASCADE
//);

//
// Enabled/Disabled billing options on the user level (globals take precedence)
//
CREATE TABLE PerUserBillingOption (
UID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1),
userProfile_UID INTEGER NOT NULL,
code VARCHAR(511) NOT NULL,
enabled BOOLEAN NOT NULL DEFAULT true,
ordinalNr SMALLINT NOT NULL DEFAULT 1,
selectedByDefault BOOLEAN NOT NULL DEFAULT false,
disablesServices VARCHAR(2047) NOT NULL DEFAULT '',
CONSTRAINT peruserbillingoption_primary_key PRIMARY KEY (UID),
CONSTRAINT peruserbillingoption_userprofile_foreign_key FOREIGN KEY (userProfile_UID) REFERENCES UserProfile(UID) ON DELETE CASCADE
);

//
// Default billing options on CargoID level
//
CREATE TABLE PerCIDBillingOption (
UID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1),
userGroup_name VARCHAR(511) NOT NULL,
cargoID INT NOT NULL DEFAULT -1,
code VARCHAR(511) NOT NULL,
enabled BOOLEAN NOT NULL DEFAULT true,
selectedByDefault BOOLEAN NOT NULL DEFAULT false,
disablesServices VARCHAR(2047) NOT NULL DEFAULT '',
CONSTRAINT percidbillingoption_primary_key PRIMARY KEY (UID)
);

CREATE TABLE TrackingSerie (
UID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1),
uniqueServerUID VARCHAR(511) NOT NULL DEFAULT '',
landNumber INTEGER NOT NULL DEFAULT 0,
billingCenter INTEGER NOT NULL DEFAULT 0,
serviceCenter INTEGER NOT NULL DEFAULT 0,
numberRangeType INTEGER NOT NULL DEFAULT 0,
numberType INTEGER NOT NULL DEFAULT 0,
cargoNetID INTEGER NOT NULL DEFAULT 0,
approvedOnServer BOOLEAN NOT NULL DEFAULT false,
deliveredToClient BOOLEAN NOT NULL DEFAULT false,
markedForRemoteDeletion BOOLEAN NOT NULL DEFAULT false,
deliveryMethod VARCHAR(15) NOT NULL DEFAULT 'HTTP',
invalidated BOOLEAN NOT NULL DEFAULT false,
name VARCHAR(255) NOT NULL DEFAULT '',
active BOOLEAN NOT NULL DEFAULT false,
baseCode INTEGER NOT NULL,
initialAmount INTEGER NOT NULL DEFAULT 0,
usedCodesAmount INTEGER NOT NULL DEFAULT 0,
warnOnAmount INTEGER NOT NULL DEFAULT 0,
cNetCreationTimestamp TIMESTAMP NOT NULL DEFAULT '1900-01-01 00:00:00',
validFromTimestamp TIMESTAMP NOT NULL DEFAULT '1900-01-01 00:00:00',
validToTimestamp TIMESTAMP NOT NULL DEFAULT '2065-12-31 23:59:59',
CONSTRAINT trackingserie_primary_key PRIMARY KEY (UID)
);

CREATE TABLE TrackingSerieEntry (
UID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1),
trackingSerie_UID INTEGER NOT NULL,
shipment_UID INTEGER NOT NULL DEFAULT 0,
packet_UID INTEGER NOT NULL DEFAULT 0,
numberCode INTEGER NOT NULL,
reserved BOOLEAN NOT NULL DEFAULT false,
reserved_SSID BIGINT NOT NULL DEFAULT 0,
printed BOOLEAN NOT NULL DEFAULT false,
invalidated BOOLEAN NOT NULL DEFAULT false,
CONSTRAINT TrackingSerieEntry_primary_key PRIMARY KEY (UID),
CONSTRAINT TrackingSerieEntry_TrackingSerie_foreign_key FOREIGN KEY (trackingSerie_UID) REFERENCES TrackingSerie(UID) ON DELETE CASCADE
);

// Ova tabela se ne koristi - DropBoxCode se uvozi iz allBoxMachines.csv fajla
CREATE TABLE DropBoxCode (
UID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1),
virtual_zip_code VARCHAR(11) NOT NULL DEFAULT '',
title VARCHAR(2047) NOT NULL DEFAULT '',
box_code VARCHAR(11) NOT NULL DEFAULT '',
zip_code VARCHAR(11) NOT NULL DEFAULT '',
address VARCHAR(2047) NOT NULL DEFAULT '',
city VARCHAR(511) NOT NULL DEFAULT '',
CONSTRAINT dropboxcode_primary_key PRIMARY KEY (UID)
// , CONSTRAINT postalcode_unique UNIQUE (postalCode, city)
);

// PostalCode se uvozi iz plzr_1.unl fajla
CREATE TABLE PostalCode (
UID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1),
country_pfx VARCHAR(15) NOT NULL,
zip_code VARCHAR(11) NOT NULL DEFAULT '',
synonym VARCHAR(11) NOT NULL DEFAULT '',
service INTEGER NOT NULL DEFAULT 0,
delivery_center VARCHAR(6) NOT NULL DEFAULT '',
valid_from TIMESTAMP NOT NULL DEFAULT '2008-09-01 00:00:00',
valid_to TIMESTAMP NOT NULL DEFAULT '2065-12-31 23:59:59',
zuzoabk VARCHAR(15) NOT NULL DEFAULT '000',
routreihenr INTEGER NOT NULL DEFAULT -1,
route_number INTEGER NOT NULL,
zuzo_routkrit1 INTEGER NOT NULL DEFAULT -1,
zuzo_routkrit2 INTEGER NOT NULL DEFAULT -1,
zuzo_routkrit3 INTEGER NOT NULL DEFAULT -1,
hdelta INTEGER NOT NULL DEFAULT -1,
city VARCHAR(511) NOT NULL,
zuzountteiltkz VARCHAR(15) NOT NULL DEFAULT '-',
pickup_deadline TIME NOT NULL DEFAULT '12:00:00',
zone_ba INTEGER NOT NULL DEFAULT 2, 
CONSTRAINT postalcode_primary_key PRIMARY KEY (UID)
// , CONSTRAINT postalcode_unique UNIQUE (postalCode, city)
);

// LocalServices se uvozi iz svcz_1.unl fajla
CREATE TABLE LocalServices (
UID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1),
country_pfx VARCHAR(15) NOT NULL,
zip_code VARCHAR(11) NOT NULL DEFAULT '',
synonym VARCHAR(11) NOT NULL DEFAULT '',
valid_from TIMESTAMP NOT NULL DEFAULT '2008-09-01 00:00:00',
valid_to TIMESTAMP NOT NULL DEFAULT '2065-12-31 23:59:59',
services VARCHAR(15) NOT NULL,
CONSTRAINT localservices_primary_key PRIMARY KEY (UID)
);

// InternationalRoute se uvozi iz lanx_1.unl fajla
CREATE TABLE InternationalRoute (
UID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1),
destinationCountryCode INTEGER NOT NULL,
destinationCenter INTEGER NOT NULL,
destinationTour INTEGER NOT NULL DEFAULT -1,
valid_from TIMESTAMP NOT NULL DEFAULT '2008-09-01 00:00:00',
valid_to TIMESTAMP NOT NULL DEFAULT '2065-12-31 23:59:59',
CONSTRAINT intlroute_primary_key PRIMARY KEY (UID)
);

// DeliveryDays se uvozi iz deliveryDaysByZIP.unl fajla; koristi se samo u Bosni (za sada)
CREATE TABLE DeliveryDays (
UID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1),
zip_code VARCHAR(11) NOT NULL DEFAULT '',
mon BOOLEAN NOT NULL DEFAULT false,
tue BOOLEAN NOT NULL DEFAULT false,
wed BOOLEAN NOT NULL DEFAULT false,
thu BOOLEAN NOT NULL DEFAULT false,
fri BOOLEAN NOT NULL DEFAULT false,
sat BOOLEAN NOT NULL DEFAULT false,
CONSTRAINT deliverydays_primary_key PRIMARY KEY (UID)
);

CREATE TABLE MerchandiseType (
UID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1),
userProfile_UID INTEGER NOT NULL,
name VARCHAR(511) NOT NULL,
isDefaultOption BOOLEAN NOT NULL DEFAULT false,
description CLOB NOT NULL DEFAULT '',
CONSTRAINT merchandisetype_primary_key PRIMARY KEY (UID),
CONSTRAINT merchandisetype_userprofile_foreign_key FOREIGN KEY (userProfile_UID) REFERENCES UserProfile(UID) ON DELETE CASCADE
);

CREATE TABLE SenderContact (
UID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1),
userProfile_UID INTEGER NOT NULL,
name VARCHAR(511) NOT NULL,
isDefaultOption BOOLEAN NOT NULL DEFAULT false,
CONSTRAINT sendercontact_primary_key PRIMARY KEY (UID),
CONSTRAINT sendercontact_userprofile_foreign_key FOREIGN KEY (userProfile_UID) REFERENCES UserProfile(UID) ON DELETE CASCADE
);

CREATE TABLE EventsLog (
UID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1),
logLevel INTEGER NOT NULL DEFAULT 1,
logStamp TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
description VARCHAR(2047) NOT NULL DEFAULT '',
CONSTRAINT eventslog_primary_key PRIMARY KEY (UID)
);

CREATE TABLE AdminLog (
UID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1),
logLevel INTEGER NOT NULL DEFAULT 1,
logStamp TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
description VARCHAR(2047) NOT NULL DEFAULT '',
CONSTRAINT adminlog_primary_key PRIMARY KEY (UID)
);

CREATE TABLE UserAppInfo (
uniqueServerUID VARCHAR(511) NOT NULL,
userAppVersion VARCHAR(255) NOT NULL DEFAULT '0.0.0',
lastSeenTimestamp TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
CONSTRAINT userappinfo_primary_key PRIMARY KEY (uniqueServerUID)
);

CREATE TABLE AutoIncrement_Ref1 (
UUID VARCHAR(511) NOT NULL, 
SSID BIGINT NOT NULL DEFAULT 0, 
number BIGINT NOT NULL DEFAULT 0, 
confirmed BOOLEAN NOT NULL DEFAULT false, 
tstamp TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
CONSTRAINT autoIncrement_Ref1_primary_key PRIMARY KEY (UUID, SSID, number)
);

CREATE TABLE NetworkPeersLAN (
UID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1),
UUID VARCHAR(511) NOT NULL, 
macAddress VARCHAR(255) NOT NULL DEFAULT '00-00-00-00-00-00', 
ipAddress VARCHAR(255) NOT NULL DEFAULT '0.0.0.0', 
lastSeen TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
CONSTRAINT networkPeersLAN_primary_key PRIMARY KEY (UID)
);

CREATE TABLE EobdIntegrationTracking (
UID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1),
userUniqueServerUID VARCHAR(511) NOT NULL,
userCargoNetID INTEGER NOT NULL DEFAULT -1,
userName VARCHAR(511) NOT NULL,
billingCenter INTEGER NOT NULL DEFAULT 1,
serviceCenter INTEGER NOT NULL DEFAULT -1,
cifVersion INTEGER NOT NULL DEFAULT -1,
numberOfShipments INTEGER NOT NULL DEFAULT 0,
numberOfParcelsValid INTEGER NOT NULL DEFAULT 0,
integratorGroupID VARCHAR(511) NOT NULL,
integratorGroupDisplayName VARCHAR(511) NOT NULL,
integratorGroupFieldName VARCHAR(511) NOT NULL,
integratorGroupProcessingTime VARCHAR(511) NOT NULL,
eobdDeliveryTimestamp TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP, 
eobdQueuedTimestamp TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP, 
eobdQueuedFileName VARCHAR(511) NOT NULL,
eobdProcessedFileName VARCHAR(511) NOT NULL DEFAULT '',
processed BOOLEAN NOT NULL DEFAULT false, 
processedStatus INTEGER NOT NULL DEFAULT -1, 
CONSTRAINT eobdIntegrationTracking_primary_key PRIMARY KEY (UID)
);

CREATE INDEX UserProfileNameIndex ON UserProfile(name ASC);
CREATE INDEX UserProfileLastEditTimestampIndex ON UserProfile(lastEditTimestamp DESC);
CREATE INDEX ShipmentUIDIndex ON Shipment(UID ASC);
CREATE INDEX ShipmentUserProfileIndex ON Shipment(userProfile_UID ASC);
CREATE INDEX ShipmentCreateTimestampIndex ON Shipment(createTimestamp ASC);
CREATE INDEX ShipmentLastEditTimestampIndex ON Shipment(lastEditTimestamp DESC);
CREATE INDEX PacketPrintTimestampIndex ON Packet(printTimestamp DESC);
CREATE INDEX TrackingSerieEntryIndex ON TrackingSerieEntry(numberCode ASC);
CREATE INDEX PerUserServiceUserUIDIndex ON PerUserService(userProfile_UID ASC);
CREATE INDEX PerUserBillingOptionUserUIDIndex ON PerUserBillingOption(userProfile_UID ASC);
CREATE INDEX EOBDReportUserUIDDelStampIndex ON EOBDReport(uniqueServerUID ASC, deliveryTimestamp ASC);
CREATE INDEX PostalCodeIndex ON PostalCode(country_pfx ASC, zip_code ASC, synonym  ASC, city ASC);
CREATE INDEX LocalServicesIndex ON LocalServices(country_pfx ASC, zip_code ASC, synonym  ASC);
CREATE INDEX TrackingSerieIndex ON TrackingSerie(landNumber ASC, serviceCenter ASC, baseCode ASC);

CREATE TABLE NetTimeStamp (
ID INTEGER NOT NULL DEFAULT 1,
LASTCHANGE TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP
);

// 1 - Shipments
// 2 - Address book
// 3 - Tracking series
INSERT INTO NetTimeStamp (ID) VALUES(1), (2), (3);

CREATE TRIGGER TIMESTAMP_SHIPMENT_INSERT AFTER INSERT ON Shipment FOR EACH STATEMENT MODE DB2SQL UPDATE NetTimeStamp SET LASTCHANGE = CURRENT_TIMESTAMP WHERE ID IN (1, 3);
CREATE TRIGGER TIMESTAMP_SHIPMENT_DELETE AFTER DELETE ON Shipment FOR EACH STATEMENT MODE DB2SQL UPDATE NetTimeStamp SET LASTCHANGE = CURRENT_TIMESTAMP WHERE ID IN (1, 3);
CREATE TRIGGER TIMESTAMP_SHIPMENT_UPDATE AFTER UPDATE ON Shipment FOR EACH STATEMENT MODE DB2SQL UPDATE NetTimeStamp SET LASTCHANGE = CURRENT_TIMESTAMP WHERE ID IN (1, 3);
CREATE TRIGGER TIMESTAMP_ADDRESSBOOK_INSERT AFTER INSERT ON Customer FOR EACH STATEMENT MODE DB2SQL UPDATE NetTimeStamp SET LASTCHANGE = CURRENT_TIMESTAMP WHERE ID = 2;
CREATE TRIGGER TIMESTAMP_ADDRESSBOOK_DELETE AFTER DELETE ON Customer FOR EACH STATEMENT MODE DB2SQL UPDATE NetTimeStamp SET LASTCHANGE = CURRENT_TIMESTAMP WHERE ID = 2;
CREATE TRIGGER TIMESTAMP_ADDRESSBOOK_UPDATE AFTER UPDATE ON Customer FOR EACH STATEMENT MODE DB2SQL UPDATE NetTimeStamp SET LASTCHANGE = CURRENT_TIMESTAMP WHERE ID = 2;
CREATE TRIGGER TIMESTAMP_TRKSERIES_INSERT AFTER INSERT ON TrackingSerie FOR EACH STATEMENT MODE DB2SQL UPDATE NetTimeStamp SET LASTCHANGE = CURRENT_TIMESTAMP WHERE ID = 3;
CREATE TRIGGER TIMESTAMP_TRKSERIES_DELETE AFTER DELETE ON TrackingSerie FOR EACH STATEMENT MODE DB2SQL UPDATE NetTimeStamp SET LASTCHANGE = CURRENT_TIMESTAMP WHERE ID = 3;
CREATE TRIGGER TIMESTAMP_TRKSERIES_UPDATE AFTER UPDATE ON TrackingSerie FOR EACH STATEMENT MODE DB2SQL UPDATE NetTimeStamp SET LASTCHANGE = CURRENT_TIMESTAMP WHERE ID = 3;
