<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.1" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:java="java"
	exclude-result-prefixes="fo" xmlns:barcode="http://barcode4j.krysalis.org/ns"
>

	<xsl:output method="xml" version="1.0" omit-xml-declaration="no" indent="no" />

	<xsl:param name="body.font.family" expression="Arial, FreeSans" />
	<xsl:param name="title.font.family" expression="Arial, FreeSans" />
	<xsl:param name="monospace.font.family" expression="Arial, FreeSans" />
	<!-- <xsl:param name="body.font.master" select="'10.1'" /> -->
	<xsl:param name="symbol.font.family" expression="Arial, FreeSans" />
	<xsl:param name="body.fontset" expression="Arial, FreeSans" />

	<xsl:include href="template://Sticker_Template.xsl" />

	<!-- ============================== -->
	<!-- Template: Report A4 Landscape -->
	<!-- ============================== -->

	<xsl:template match="report">
		<fo:root font-family="Arial, FreeSans">
			<fo:layout-master-set>
				<fo:simple-page-master master-name="whole_page" page-width="297mm" page-height="210mm" margin-top="4mm" margin-bottom="0mm" margin-left="10mm"
					margin-right="10mm" reference-orientation="{/report/printLabelsRotationDegrees}"
				>
					<fo:region-body margin-left="0" margin-right="0" margin-top="0" margin-bottom="0" />
				</fo:simple-page-master>
			</fo:layout-master-set>

			<xsl:for-each select="stickersInfo/stickersQuadRow">
				<fo:page-sequence master-reference="whole_page">
					<fo:flow flow-name="xsl-region-body">
						<xsl:for-each select="stickersRow">
							<xsl:apply-templates select="." />
						</xsl:for-each>
					</fo:flow>
				</fo:page-sequence>
			</xsl:for-each>
		</fo:root>
	</xsl:template>

	<xsl:template match="stickersRow">
		<fo:block>
			<fo:table width="100%">
				<fo:table-body>
					<fo:table-row height="98mm">
						<xsl:choose>
							<xsl:when test="count(sticker) = 2">
								<fo:table-cell width="135mm" padding="0">
									<xsl:apply-templates select="sticker[2]" />
								</fo:table-cell>
								<fo:table-cell width="7mm" padding-left="3.5mm">
									<xsl:call-template name="separator_vertical" />
								</fo:table-cell>
								<fo:table-cell width="135mm" padding="0">
									<xsl:apply-templates select="sticker[1]" />
								</fo:table-cell>
							</xsl:when>
							<xsl:otherwise>
								<fo:table-cell width="135mm" padding="0">
									<xsl:call-template name="sticker_empty" />
								</fo:table-cell>
								<fo:table-cell width="7mm" padding-left="3.5mm">
									<xsl:call-template name="separator_vertical" />
								</fo:table-cell>
								<fo:table-cell width="135mm" padding="0">
									<xsl:apply-templates select="sticker[1]" />
								</fo:table-cell>
							</xsl:otherwise>
						</xsl:choose>
					</fo:table-row>
					<xsl:if test="@UID mod 2 = 1">
						<fo:table-row height="4mm">
							<fo:table-cell width="135mm" padding="0">
								<xsl:call-template name="separator_horizontal" />
							</fo:table-cell>
							<fo:table-cell width="7mm" padding="0">
								<fo:block width="7mm" height="6mm"></fo:block>
							</fo:table-cell>
							<fo:table-cell width="135mm" padding="0">
								<xsl:call-template name="separator_horizontal" />
							</fo:table-cell>
						</fo:table-row>
					</xsl:if>
				</fo:table-body>
			</fo:table>
		</fo:block>
	</xsl:template>

</xsl:stylesheet>

